<template>
  <div>
    <VRow justify="space-between">
      <VCol cols="12" md="6" lg="5">
        <div class="text-h4">Дымоходы.Вентканалы</div>
      </VCol>
      <OutagesFilters @filter-updated="updateFilter" :region="regions" :onlyYear="false" :firstDate="'01.02.2000'" />
    </VRow>

    <PlaceholderPage
      v-if="filterEmpty || pending"
      :text="placeholderText"
    />

    <template v-else>
      <div class="outages__top top-outages">
        <div v-for="(card, i) in cardStats" :key="i" class="top-outages__item">
          <div v-if="card.head" class="unit__head">{{ card.head }}</div>
          <div
            :class="['d-flex flex justify-space-between unit unit--stats', {
              'align-end': card.alignEnd,
            }]"
          >
            <div class="unit__col">
              <div class="unit__title">{{ card.left.caption }}</div>
              <div class="unit__value text-h5 font-weight-semibold">{{ card.left.value }}</div>
              <div v-if="card.left.bottom" class="unit__value text-h5 font-weight-semibold">{{ card.left.bottom }}</div>
            </div>
            <div
              :class="['unit__col unit__col--right', {
                'justify-space-between fill-height': card.right.fillHeight,
              }]"
            >
              <div class="unit__title">{{ card.right.caption }}</div>
              <div
                :class="['unit__value text-h5 font-weight-semibold', {
                  'unit__value--end': card.alignEnd, 'unit_tar': card.right }]">
                {{ card.right.value }}
              </div>
              <div v-if="card.right.bottom" class="unit__value text-h5 font-weight-semibold">{{ card.right.bottom }}</div>
            </div>
          </div>
        </div>
      </div>

      <div class="outages__grd grid-outages">
        <div class="grid-outages__item">
          <div
          class="flex-grow-1"
          :class="$style.unit"
          >
            <VentilationDiagram
              title="Совокупные данные"
              :meaning="diagramDataOne"
              :theme-mode="themeMode"
            />
          </div>
        </div>
        <div class="grid-outages__item">
          <div
          class="flex-grow-1"
          :class="$style.unit"
          >
            <VentilationDiagram
              title="Износ систем"
              :meaning="diagramDataTwo"
              :theme-mode="themeMode"
            />
          </div>
        </div>
        <div class="grid-outages__item">
          <div
          class="flex-grow-1"
          :class="$style.unit"
          >
            <CollectionCurrencyCharts
              title="Восстановление систем"
              :meaning="collectionCurrencyChartsData"
              :yaxis-labels-formatter="chart3Formatter"
              :theme-mode="themeMode"
              :dataLabelsFormatter="dataLabelsFormatter"
            />
          </div>
        </div>
        <div class="grid-outages__item">
          <div
          class="flex-grow-1"
          :class="$style.unit"
          >
            <JobsTypesCharts
            title="Рейтинг аварийности МО и ГО РБ в процентном соотношении"
            :meaning="jobsTypesChartsData"
            :theme-mode="themeMode" />
          </div>
        </div>
        <div class="grid-outages__item">
          <div
          class="flex-grow-1"
          :class="$style.unit"
          >
            <CollectionCurrencyCharts
              title="Затраты на восстановление систем план/факт 2022"
              :meaning="collectionCurrencyChartsDataTwo"
              :yaxis-labels-formatter="chart3Formatter"
              :theme-mode="themeMode"
              :dataLabelsFormatter="dataLabelsFormatter"
            />
          </div>
        </div>
        <div
          class="grid-outages__item grid-outages__item_map"
          :class="$style.gridOutagesMap"
        >
          <div class="unit flex-grow-1">
            <OverhaulMap :theme-mode="themeMode" :mapData="mapData" />
          </div>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
import { VCol, VRow } from "vuetify/lib";
import PlaceholderPage from "@/components/Overhaul/PlaceholderPage";
import OverhaulMap from "@/components/Overhaul/OverhaulMap";
import OutagesFilters from "@/components/Outages/OutagesFilters";
import VentilationDiagram from "@/components/Ventilation/VentilationDiagram";
import CollectionCurrencyCharts from "@/components/Overhaul/CollectionCurrencyCharts";
import JobsTypesCharts from '@/components/Overhaul/JobsTypesCharts';
import { convertIntegerToText } from "@/constants/helpers";

export default {
  name: 'OverhaulIndex',
  components: {
    VRow,
    VCol,
    PlaceholderPage,
    OutagesFilters,
    OverhaulMap,
    VentilationDiagram,
    CollectionCurrencyCharts,
    JobsTypesCharts,
  },
  apollo: {
    getVentilationsHousesMunicipalities: {
      query: require('@/graphql/getVentilationsHousesMunicipalities.gql'),
      result(response) {
        const regions = response?.data?.getVentilationsHousesMunicipalities?.map(item => ({
          fullName: item.title,
          objectId: item.title,
        })) || [];
        this.regions = [
          {
            fullName: 'Республика Башкортостан',
            objectId: null,
          },
          ...regions,
        ];
      },
    },
    getVentilationDashboard: {
      query: require('@/graphql/getVentilationDashboard.gql'),
      fetchPolicy: 'network-only',
      variables() {
        return {
          periodStart: this.filter.period?.[0]?.toString(),
          periodEnd: this.filter.period?.[1]?.toString(),
          houseMunicipality: this.filter.region,
          ...(this.filter.region === null) ? { houseMunicipality: undefined } : {},
        }
      },
      skip() {
        return this.filter.period?.length < 2;
      },
      result(response) {
        const { data: { getVentilationDashboard: result } } = response;

        this.cards = {
          housesWithGasAppliances: result?.housesWithGasAppliances || 0,
          apartmentsWithGasAppliances: result?.apartmentsWithGasAppliances || 0,
          gasShutdownedWithGasDispenserHouses: result?.gasShutdownedWithGasDispenserHouses || 0,
          gasShutdownedWithGasDispenserApartments: result?.gasShutdownedWithGasDispenserApartments || 0,
          gasShutdownedWithoutGasDispenserHouses: result?.gasShutdownedWithoutGasDispenserHouses || 0,
          gasShutdownedWithoutGasDispenserApartments: result?.gasShutdownedWithoutGasDispenserApartments || 0,
          totalVentilationChannelsCount: result?.totalVentilationChannelsCount || 0,
          totalChimneys: result?.totalChimneys || 0,
          emergencyVentilationChannelsCount: result?.emergencyVentilationChannelsCount || 0,
          emergencyChimneys: result?.emergencyChimneys || 0,
        }

        const systemsDeteriorations = result?.systemsDeteriorations || {};
        delete systemsDeteriorations.__typename;

        this.systemsDeteriorations = {
          ...this.systemsDeteriorations,
          ...systemsDeteriorations,
        }

        const systemsRepairs = result?.systemsRepairs || {};
        delete systemsRepairs.__typename;
        this.systemsRepairs = systemsRepairs;

        const systemsRepairCost = result?.systemsRepairCost || {};
        delete systemsRepairCost.__typename;
        this.systemsRepairCost = systemsRepairCost;
      },
    },
  },
  data() {
    return {
      cards: {
        housesWithGasAppliances: 0,
        apartmentsWithGasAppliances: 0,
        gasShutdownedWithGasDispenserHouses: 0,
        gasShutdownedWithGasDispenserApartments: 0,
        gasShutdownedWithoutGasDispenserHouses: 0,
        gasShutdownedWithoutGasDispenserApartments: 0,
        totalVentilationChannelsCount: 0,
        totalChimneys: 0,
        emergencyVentilationChannelsCount: 0,
        emergencyChimneys: 0,
      },
      regions: [{
        fullName: 'Республика Башкортостан',
        objectId: null,
      }],
      diagramDataOne: {
        sideTexts: [
          {
            title: 'Проверенные по Ф20 Газ Рабочие',
            keys: ['Дымоходы', 'Вентканалы'],
            values: [60206, 422385],
            color: '#42b983'
          },
          {
            title: 'Не проверенные по Ф20 Газ Рабочие',
            keys: ['Дымоходы', 'Вентканалы'],
            values: [56411, 280384],
            color: '#486491'
          },
          {
            title: 'Аварийные',
            keys: ['Дымоходы', 'Вентканалы'],
            values: [1335, 2319],
            color: '#d63200'
          },
        ],
        data: {
          series: [55, 43.5, 1.5],
          labels: ['УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%', 'УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%', 'УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%']
        },
        colors: ['#00a759', '#0093cb', '#fc2626'],
      },
      systemsDeteriorations: {
        goodVentilationsCount: 0,
        goodChimneysCount: 0,
        tolerableVentilationsCount: 0,
        tolerableChimneysCount: 0,
        intolerableVentilationsCount: 0,
        intolerableChimneysCount: 0,
        emergencyVentilationsCount: 0,
        emergencyChimneysCount: 0,
      },
      systemsRepairs: {
        inspectedChimneysCount: 0,
        inspectedVentilationsCount: 0,
        repairedChimneysCount: 0,
        repairedVentilationCount: 6,
      },
      systemsRepairCost: {
        currentFactualCost: 0,
        currentPlannedCost: 0,
        newFactualCost: 0,
        newPlannedCost: 0,
        overhaulFactualCost: 0,
        overhaulPlannedCost: 0,
        reconstructionFactualCost: 0,
        reconstructionPlannedCost: 0,
        totalFactualCost: 0,
        totalPlannedCost: 0,
      },
      jobsTypesChartsData: {
        titles: [
          'Уфа ГО',
          'Учалинский р-н',
          'Салават ГО',
          'Гафурийский р-н',
          'Баймакский р-н',
          'Абзелиловский р-н'
        ],
        values: [0, 0, 0, 0, 0, 0],
        formatter: function(val) {
          return val + '%'
        }
      },
      filter: {
        period: [],
        region: null,
      },
      mapData: {
        typename: 'VentilationDashboard',
        items: [
          {
            coord: [54.74728667873139, 55.9947550905636],
            title: 'Достоевского ул., д.83',
            greentext: {
              left: 'Дата отключения подачи газа',
              right: '28.06.2022'
            },
            rows: [
              {
                black: 'Способ управления МКД',
                grey: 'УК ООО "Управляющая компания"'
              },
              {
                black: 'Затраты на восстановление',
                grey: '0000000 руб.'
              },
              {
                black: 'Источник финансирования',
                grey: 'Бюджет МО'
              },
              {
                black: 'Причина отключения',
                grey: 'Заключение проверки работоспособности дымохода - нет тяги.'
              },
            ]
          }
        ]
      }}
  },
  computed: {
    themeMode() {
      return this.$vuetify.theme.dark ? 'dark' : 'light';
    },
    pending() {
      return this.$apollo.queries.getVentilationDashboard.loading;
    },
    filterEmpty() {
      return this.filter.period?.length < 2;
    },
    placeholderText() {
      return this.pending ? 'Загружаем данные' : 'Выберите период и регион для отображения данных'
    },
    cardStats() {
      return [
        {
          head: 'Всего с газовым оборудованием',
          left: { caption: 'МКД', value: convertIntegerToText(this.cards.housesWithGasAppliances) },
          right: { caption: 'КВ', value: convertIntegerToText(this.cards.apartmentsWithGasAppliances) },
        },
        {
          head: 'Отключено по предписанию',
          left: { caption: 'с газ. колонкой', value: `МКД - ${convertIntegerToText(this.cards.gasShutdownedWithGasDispenserHouses)}`, bottom: `КВ - ${convertIntegerToText(this.cards.gasShutdownedWithGasDispenserApartments)}` },
          right: { caption: 'без газ. колонки', value: `МКД - ${convertIntegerToText(this.cards.gasShutdownedWithoutGasDispenserHouses)}`, bottom: `КВ-${convertIntegerToText(this.cards.gasShutdownedWithoutGasDispenserApartments)}`},
          alignEnd: true,
        },
        {
          head: 'Всего систем',
          left: { caption: 'Вентканалы', value: convertIntegerToText(this.cards.totalVentilationChannelsCount) },
          right: { caption: 'Дымоходы', value: convertIntegerToText(this.cards.totalChimneys) },
        },
        {
          head: 'Всего в аварийном состоянии',
          left: { caption: 'Вентканалы', value: convertIntegerToText(this.cards.emergencyVentilationChannelsCount) },
          right: { caption: 'Дымоходы', value: convertIntegerToText(this.cards.emergencyChimneys)},
        },
      ]
    },
    diagramDataTwo() {
      const all = Object.values(this.systemsDeteriorations).reduce((sum, item) => sum + (parseInt(item, 10) || 0), 0);

      const countGood = this.systemsDeteriorations.goodChimneysCount + this.systemsDeteriorations.goodVentilationsCount;
      const countTolerable = this.systemsDeteriorations.tolerableChimneysCount + this.systemsDeteriorations.tolerableVentilationsCount;
      const countIntolerable = this.systemsDeteriorations.intolerableChimneysCount + this.systemsDeteriorations.intolerableVentilationsCount;
      const countEmergency = this.systemsDeteriorations.emergencyChimneysCount + this.systemsDeteriorations.emergencyVentilationsCount;

      const percentGood = Number((countGood / all * 100).toFixed(2)) || 25;
      const percentTolerable = Number((countTolerable / all * 100).toFixed(2)) || 25;
      const percentIntolerable = Number((countIntolerable / all * 100).toFixed(2)) || 25;
      const percentEmergency = Number((countEmergency / all * 100).toFixed(2)) || 25;

      return {
        sideTexts: [
          {
            title: '0 - 21% хорошее состояние',
            keys: [ 'Дымоходы', 'Вентканалы' ],
            values: [ this.systemsDeteriorations.goodChimneysCount, this.systemsDeteriorations.goodVentilationsCount ],
            color: '#42b983'
          },
          {
            title: '21 - 40% удовлетворительное состояние',
            keys: [ 'Дымоходы', 'Вентканалы' ],
            values: [ this.systemsDeteriorations.tolerableChimneysCount, this.systemsDeteriorations.tolerableVentilationsCount ],
            color: '#486491'
          },
          {
            title: '41 - 60% не удовлетворительное состояние',
            keys: [ 'Дымоходы', 'Вентканалы' ],
            values: [ this.systemsDeteriorations.intolerableChimneysCount, this.systemsDeteriorations.intolerableVentilationsCount ],
            color: '#fca326'
          },
          {
            title: '61 - 100% аварийное состяние',
            keys: [ 'Дымоходы', 'Вентканалы' ],
            values: [ this.systemsDeteriorations.emergencyChimneysCount, this.systemsDeteriorations.emergencyVentilationsCount ],
            color: '#d63200'
          },
        ],
        data: {
          series: [ percentGood, percentTolerable, percentIntolerable, percentEmergency ],
          labels: [
            'УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%',
            'УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%',
            'УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%',
            'УК - 00 ед. 00% <br> ТСЖ - 00 ед. 00% <br> НСУ - 00 ед. 00%'
          ]
        },
        colors: [ '#00a759', '#0093cb', '#fc2626', '#fca326' ],
      };
    },
    collectionCurrencyChartsData() {
      return {
        titles: [ 'Обследование', 'Ремонт' ],
        series: [{
          name: 'Вент. ед',
          data: [ this.systemsRepairs.inspectedVentilationsCount, this.systemsRepairs.inspectedChimneysCount ],
        }, {
          name: 'Дым. ед',
          data: [ this.systemsRepairs.repairedVentilationCount, this.systemsRepairs.repairedChimneysCount ],
        }],
        colors: [ '#d63200', '#486491' ],
        distributed: false,
        showLegend: true,
      };
    },
    collectionCurrencyChartsDataTwo() {
      const planned = convertIntegerToText(this.systemsRepairCost.totalPlannedCost);
      const factual = convertIntegerToText(this.systemsRepairCost.totalFactualCost);

      return {
        titles: [ 'Текущий', 'Капитальный', 'Реконструкция', 'Новый' ],
        series: [{
          name: `План, ${planned} руб.`,
          data: [
            this.systemsRepairCost.currentPlannedCost,
            this.systemsRepairCost.overhaulPlannedCost,
            this.systemsRepairCost.reconstructionPlannedCost,
            this.systemsRepairCost.newPlannedCost,
          ],
        }, {
          name: `Факт, ${factual} руб.`,
          data: [
            this.systemsRepairCost.currentFactualCost,
            this.systemsRepairCost.overhaulFactualCost,
            this.systemsRepairCost.reconstructionFactualCost,
            this.systemsRepairCost.newFactualCost,
          ],
        }],
        colors: [ '#d63200', '#486491' ],
        distributed: false,
        showLegend: true,
      };
    },
  },
  watch: {
    '$apollo.loading'(pending) {
      this.$emit('change-loading', pending);
    }
  },
  methods: {
    chart3Formatter: (val) => Number(val) / 1000000,
    dataLabelsFormatter:  (val) => convertIntegerToText(val),
    updateFilter(filter) {
      this.filter.region = this.index === 0 ? 95230709 : filter.region;
      this.filter.period = filter.period?.map(date => {
        const [day, month, year] = date?.split('.');
        return `${year}-${month}-${day}`;
      })
    },
    updateMapData(newData) {
      let arr = [];
      let obj = {};
      this.mapData.typename = newData.__typename;
      obj.coord = [54.74728667873139, 55.9947550905636];
      obj.totalHouses = newData.totalHouses;
      obj.totalWorks = newData.totalWorks;
      obj.worksByTypes = newData.worksByTypes;
      arr.push(obj)
      this.mapData.items = arr;
    },
  },
};
</script>

<style lang="scss">
.overhaul-placeholder {
  min-height: 300px;
}

.top-outages {
  display: grid;
  gap: 24px;
  margin-top: 24px;
  grid-template-columns: repeat(4, 1fr);
  @media (max-width: 1360px){
    grid-template-columns: repeat(2, 1fr);
  }
  @media (max-width: 767px) {
    grid-template-columns: repeat(1, 1fr);
  }

  &__item {
    display: flex;
    flex-direction: column;
  }
}

.unit__head {
  padding: 0 10px;
  text-align: center;
}
.unit_tar {
  text-align: right;
}

.grid-outages {
  display: grid;
  grid-template-columns: repeat(3, calc(34% - 26px));
  gap: 24px;
  margin-top: 24px;
  @media (max-width:1360px){
    grid-template-columns: repeat(2, calc(50% - 13px));
  }
  @media (max-width:950px) {
    grid-template-columns: repeat(1, 100%);
  }

  &__item {
    display: flex;
    &-1-3 {
      .unit {
        max-width: 100%;
      }
      @media (min-width:950px){
        grid-column-start: 1;
        grid-column-end: 3;
      }
    }

    &_map {
      height: 100%;
      @media (min-width:1360px) {
        grid-column-start: 3;
        grid-column-end: 4;
        grid-row-start: 2;
        grid-row-end: 4;
      }
    }
  }
}
.leaflet-control [href="https://leafletjs.com"] {
  display: none !important;
}
</style>
<style lang="scss" module>
  .gridOutagesMap {
    @media (min-width:1360px) {
      grid-column-start: 3;
      grid-column-end: 4;
      grid-row-start: 2;
      grid-row-end: 3;
    }
  }
.unit {
  padding: 18px 16px;
  border-radius: 16px;
  transition: .3s;
  max-width: 100%;
  &>div {
    display: flex;
    flex-direction: column;
    height: 100%;
    max-width: 100%;
    justify-content: center;
  }
}
.unit:hover {
  background-color: var(--v-unitHover-base) !important
}
.unit {
    background-color: var(--v-unit-base) !important;
    border-color: var(--v-unit-base) !important;
}
</style>
